package c4;

/**
How to use this class:
	1. Add all student AI agents to the c4.contestants package. You will likely want to rename each student's class to avoid confusion.
	2. Add student names (or some other identifier) to the array of Strings on line 33.
	3. For each student agent, add a case to the switch statement that begins on line 135. Each case should return a single student's agent.
		Add cases in numerical order, starting from zero.
*/

import java.io.FileWriter;
import java.io.IOException;

import c4.mvc.ConnectFourController;
import c4.mvc.ConnectFourModel;
import c4.players.ConnectFourPlayer;
import c4.contestants.*; //TODO: Place student agents in c4.contestants package

public class ConnectFourTournament {

	public static void main(String[] args) {
		try{
			int start_i = 0;
			int start_j = 0;
			playTournament(start_i, start_j);
		}
		catch(IOException ioe){
			
		}
	}
	
	public static void playTournament(int start_i, int start_j) throws IOException{
		String[] player_names = {}; //TODO: Add student names or other identifiers to this array
		int[] wins = new int[player_names.length];
		int[] losses = new int[player_names.length];
		int[] draws = new int[player_names.length];
		int[] points = new int[player_names.length];
		int gameCounter = 0;
		
		FileWriter results = new FileWriter("results-by-game.csv", true);
		results.write("Player 1,Player 2,P1 Pts,P2 Pts\n");
		
		for(int i=0; i<player_names.length; i++){
			for(int j=0; j<player_names.length; j++){
				if(i==j)
					continue;
				else if(i < start_i){
					gameCounter++;
					System.out.println(gameCounter);
					continue;
				}
				else if(i == start_i && j < start_j){
					gameCounter++;
					System.out.println(gameCounter);
					continue;
				}
				try{
					results.flush();
					gameCounter++;
					System.out.println(gameCounter);
					ConnectFourModel model = new ConnectFourModel();
					ConnectFourPlayer p1 = retrievePlayer(i,1,model);
					ConnectFourPlayer p2 = retrievePlayer(j,2,model);
					
					ConnectFourController con = new ConnectFourController(model, p1, p2, false);
					int winner = con.start();
					
					switch(winner){
					case 0:
						points[i] += 1;
						points[j] += 1;
						draws[i] += 1;
						draws[j] += 1;
						results.write(i+","+j+",1,1\n");
						System.out.println(player_names[i]+" and "+player_names[j]+ "tied");
						break;
					case 1:
						points[i] += 2;
						wins[i] += 1;
						losses[j] += 1;
						results.write(i+","+j+",2,0\n");
						System.out.println(player_names[i]+" defeated "+player_names[j]);
						break;
					case 2:
						points[j] += 2;
						wins[j] += 1;
						losses[i] += 1;
						results.write(i+","+j+",0,2\n");
						System.out.println(player_names[j]+" defeated "+player_names[i]);
						break;
					}
				}
				catch(IllegalMoveException e){
					int player = e.getPlayer();
					if(player == 1){
						points[j] += 2;
						wins[j] += 1;
						losses[i] += 1;
						results.write(i+","+j+",0,2,Forfeit\n");
						System.out.println(player_names[j]+" defeated "+player_names[i]+" by forfeit");
					}
					else if(player == 2){
						points[i] += 2;
						wins[i] += 1;
						losses[j] += 1;
						results.write(i+","+j+",2,0,Forfeit\n");
						System.out.println(player_names[i]+" defeated "+player_names[j]+" by forfeit");
					}
				}
				catch(IOException ioe){
					System.err.println("IO Failure during tournament");
				}
				catch(Exception e){
					e.printStackTrace();
					System.out.println("Game failed for "+i+" vs "+j);
					results.write(i+","+j+",-,-,REPLAY NEEDED\n");
				}
			}
		}
		
		results.close();
		
		// Only works from 0,0
		FileWriter standings = new FileWriter("standings.csv");
		standings.write("Player,W,L,D,Pts\n");
		for(int p=0; p<player_names.length; p++){
			String standings_string = player_names[p]+","+wins[p]+","+losses[p]+","+draws[p]+","+points[p]+"\n";
			standings.write(standings_string);
		}
		standings.close();
	}

	private static ConnectFourPlayer retrievePlayer(int p, int playerNum, ConnectFourModel model) {
		int depth = 8;
		switch(p){
			//TODO: Add a case for each student contestant in numerical order starting from 0. Examples below.
		//case 0:
			//return new JaneDoePlayer(model, depth);
		//case 1:
			//return new GraceHopperPlayer(model, depth);
		
		return null;
	}

}
