'''
How to use this script:
	1. Add all student AI agents to the folder containing this code. You will likely
		want to rename each student's script to avoid confusion.
	2. For each student, add an import statement to include their agent class, like the examples on lines 17-18.
	3. Add student names (or some other identifier as a string) to the list on line 29.
	4. For each student agent, add an if statement to the block beginning on line 119. Each case should return a single student's agent.
		Add cases in numerical order, starting from zero.
'''

from c4controller import ConnectFourController
from c4model import ConnectFourModel
from c4players import ConnectFourPlayer
from c4exceptions import IllegalMoveError

# Example student imports
#from doe import ConnectFourAIPlayer as JaneDoePlayer
#from hopper import ConnectFourAIAgent as GraceHopperPlayer

def main():
	try:
		start_i = 0
		start_j = 0
		playTournament(start_i, start_j)
	except:
		pass
		
def playTournament(start_i, start_j):
	player_names = [] #TODO: Add student names or other identifiers to this list of strings
	wins = [0] * len(player_names)
	losses = [0] * len(player_names)
	draws = [0] * len(player_names)
	points = [0] * len(player_names)
	gameCounter = 0
	
	results = open('results-by-game-python.csv', 'a')
	results.write("Player 1,Player 2,P1 Pts,P2 Pts\n")
	
	for i in range(len(player_names)):
		for j in range(len(player_names)):
			if i == j:
				continue
			elif i < start_i:
				gameCounter += 1
				print(gameCounter)
				continue
			elif i == start_i and j < start_j:
				gameCounter += 1
				print(gameCounter)
				continue
			try:
				results.flush()
				gameCounter += 1
				print(gameCounter)
				model = ConnectFourModel()
				p1 = retrievePlayer(i,1,model)
				p2 = retreivePlayer(j,2,model)
				
				con = ConnectFourController(model, p1, p2, False)
				winner = con.start()
				
				if winner == 0:
					points[i] += 1
					points[j] += 1
					draws[i] += 1
					draws[j] += 1
					results.write(str(i)+','+str(j)+',1,1\n')
					print(player_names[i]+' and '+player_names[j]+' tied')
				elif winner == 1:
					points[i] += 2
					wins[i] += 1
					losses[j] += 1
					results.write(str(i)+','+str(j)+',2,0\n')
					print(player_names[i]+' defeated '+player_names[j])
				elif winner == 2:
					points[j] += 2
					wins[j] += 1
					losses[i] += 1
					results.write(str(i)+','+str(j)+',0,2\n')
					print(player_names[j]+' defeated '+player_names[i])
			except IllegalMoveError as e:
				player = e.get_player()
				if player == 1:
					points[j] += 2
					wins[j] += 1
					losses[i] += 1
					results.write(str(i)+','+str(j)+',0,2,Forfeit\n')
					print(player_names[j]+' defeated '+player_names[i]+' by forfeit')
				elif player == 2:
					points[i] += 2
					wins[i] += 1
					losses[j] += 1
					results.write(str(i)+','+str(j)+',2,0,Forfeit\n')
					print(player_names[i]+' defeated '+player_names[j]+' by forfeit')
			except IOError:
				print('IO failure during tournament')
			except Exception as exc:
				print(exc)
				print('Game failed for '+str(i)+' vs '+str(j))
				results.write(str(i)+','+str(j)+',-,-,REPLAY NEEDED\n')
	
	results.close()
	
	# Only works from first game (0,0) in loop above
	standings = open('standings-python.csv','w')
	standings.write('Player,W,L,D,Pts\n')
	for p in range(len(player_names)):
		standings.write(player_names[p]+',')
		standings.write(str(wins[p])+','+str(losses[p])+',')
		standings.write(str(draws[p])+','+str(points[p])+'\n')
	standings.close()
	
def retrievePlayer(p, playerNum, model):
	depth = 8
	
	# TODO: Add an if statement for each student contestant in numerical order
	# starting from zero. Examples below.
	
	if p == 0:
		return JaneDoePlayer(model, depth)
	if p == 1:
		return GraceHopperPlayer(model, depth)
		
	return None